#
# spec file for package cross-arm-gcc (Version 2.95.3)
# 
# Copyright  (c)  2001  SuSE GmbH  Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
# 
# please send bugfixes or comments to feedback@suse.de.
#

# neededforbuild  autoconf cross-arm-binutils cross-arm-glibc cross-arm-lx_suse
# usedforbuild    aaa_base aaa_dir autoconf automake base bash bindutil binutils bison bzip compress cpio cpp cracklib cross-arm-binutils cross-arm-glibc cross-arm-lx_suse cyrus-sasl db devs diffutils e2fsprogs file fileutils findutils flex gawk gcc gdbm gdbm-devel gettext glibc glibc-devel gpm gppshare grep groff gzip kbd less libtool libz m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg pam pam-devel patch perl ps rcs readline rpm sendmail sh-utils shadow strace syslogd sysvinit texinfo textutils timezone unzip util-linux vim

Name:         cross-arm-gcc
Copyright:    GPL
Group:        Development
Provides:     cross-arm-cc cross-arm-c++
Requires:     cross-arm-binutils cross-arm-lx_suse cross-arm-glibc
Conflicts:    cross-arm-gcc-core
Autoreqprov:  off
Version:      2.95.3
Release:      71
Summary:      GCC cross-compiler for ARM targets
Prefix:       /opt/cross
Buildroot:    /tmp/cross-arm-gcc-build
Source:       ftp://ftp.gnu.org/pub/gnu/gcc/gcc-2.95.3.tar.bz2
Source1:      libg++-2.8.1.3.tar.gz
Source2:      ftp://agnes.dida.physik.uni-essen.de/gnu-pascal/alpha/gpc-20010317.tar.gz
# the IBM patches contain the GPL along with the patch, thus they are ,,sources''
Source3:      ftp://www10.software.ibm.com/developerworks/opensource/linux390/src/gcc-2.95.3-s390.tar.gz
Patch: gcc-2.95.2-complex.dif
Patch2: libobjc.diff
Patch3: gcc-include.dif
Patch4: ada.diff
Patch5: gpc.diff
# Patch7: pascal.diff
# Patch8: gcc-exception-fix.diff
Patch9: gcc-accept-doublecolon.diff
Patch10: gcc.disable-rerun.patch
Patch14: gcc-extension-warn.diff
Patch16: alpha-extra.diff
Patch18: gcc-2.95.2-rs6000.diff
Patch20: gcc-2.95.3-version.diff
Patch21: weak.diff
Patch22: crtstuff.diff
Patch23: gcc-2.95.4-1.patch
Patch24: ppc.diff
Patch25: regmove.patch
Patch50: gcc-2.95.3-to-cvs-for-ppc.diff
Patch51: cvs-2_95-branch-ppc.diff
Patch52: cvs-2_95-branch-ppc_zzz_version.diff

%description
This is the standard SuSE GCC, modified for use in
cross-development. The GNU compiler collection only supports
cross-compilation in C and C++, so those are the only two languages
prepared. It is intended for people who want to develop for a ARM
target from a more capable desktop computer. This package can be handy
even if you are running on an ARM development platform, as it allows
you to decouple the host development system from that of your embedded
system, i.e., you can update one without the other.

Authors:
--------
    Adam Fedor <fedor@colorado.edu>
    Alan Modra <alan@spri.levels.unisa.edu.au>
    Allen Briggs <briggs@rrinc.com>
    Andreas Schwab <schwab@suse.de>
    Andrew Cagney <cagney@highland.com.au>
    Andrew McCallum <mccallum@leopard.cs.rochester.edu>
    Arne H. Juul <arnej@idt.unit.no>
    Craig Burley <burley@gnu.ai.mit.edu>
    DJ Delorie <dj@delorie.co)m
    David Edelsohn <edelsohn@mhpcc.edu>
    Doug Evans <dje@cygnus.com>
    Douglas Rupp <drupp@cs.washington.edu>
    Fergus Henderson <fjh@cs.mu.oz.au>
    Gran Uddeborg <uddeborg@carmen.se>
    Ian Lance Taylor <ian@cygnus.com>
    Jrn Rennecke <amylaar@meolyon.hanse.de>
    J.T. Conklin <jtc@cygnus.com>
    Jason Merrill <jason@cygnus.com>
    Jeffrey A. Law <law@cygnus.com>
    Jim Meyering <meyering@na-net.ornl.gov>
    Jim Wilson <wilson@cygnus.com>
    John F. Carr <jfc@mit.edu>
    Ken Raeburn <raeburn@wombat.gnu.ai.mit.edu>
    Lee Iverson <leei@ai.sri.com>
    Linus Torvalds <torvalds@transmeta.com>
    Michael Gschwind <mike@lanai.vlsivie.tuwien.ac.at>
    Michael Meissner <meissner@cygnus.com>
    Mike Stump <mrs@cygnus.com>
    Niklas Hallqvist <niklas@appli.se>
    Oliver Kellogg <oliver.kellogg@space.otn.dasa.de>
    Pat Rankin <rankin@eql.caltech.edu>
    Paul Eggert <eggert@twinsun.com>
    Per Bothner <bothner@cygnus.com>
    Peter Flass <flass@lbdrscs.bitnet>
    Philippe De Muyter <phdm@info.ucl.ac.be>
    Richard Earnshaw <rearnsha@armltd.co.uk>
    Richard Kenner <kenner@vlsi1.ultra.nyu.edu>
    Richard Stallman <rms@mole.gnu.ai.mit.edu>
    Roland McGrath <roland@churchy.gnu.ai.mit.edu>
    Stan Cox <coxs@dg-rtp.dg.com>
    Stephen L Moshier <moshier@world.std.com>
    Ted Lemon <mellon@toccata.fugue.com>
    Tom Quiggle <quiggle@lovelace.engr.sgi.com>
    Torbjorn Granlund <tege@cygnus.com>
    Uwe Seimet <seimet@chemie.uni-kl.de>

SuSE series: d

%define HOST %(echo %{_target_cpu}|sed -e "s/i.86/i486/" -e "s/ppc/powerpc/")-suse-linux
%define TARGET arm-linux
%prep
%setup -q -n gcc-2.95.3 -a 1 -a 2
if echo %{TARGET}|grep -q s390
then
# unpack the IBM-s390 patches
%setup -T -D -a 3 -n gcc-2.95.3
fi
# the texinfo(1)-sources are included in the gcc-distribution.  we
# don't need it here:
rm -rf texinfo
# integrate libg++ and gpc sources into gcc build tree:
mv libg++-2.8.1.3/* .
mv gpc-20010317/p gcc
rmdir libg++-2.8.1.3 gpc-20010317
%patch
%patch18
%patch2 -p1
%patch3
%patch4
%patch9
%patch10
cd gcc; patch -p1 < p/diffs/gcc-2.95.2.diff
%patch5 -p1
cd ..
if echo %{TARGET}|grep -q s390
then
# apply the IBM-s390-patches
patch -p1 --input=gcc-2.95.3-s390.diff
fi
%patch16
# we already use the cvs
if ! echo %{TARGET}|grep -q powerpc
then
%patch14 -p1
%patch20
%patch21
%patch22
%patch25
fi
if echo %{TARGET}|grep -q powerpc
then
#%patch23
#%patch24
# update to current cvs...
%patch50 -p1
# use franzos latest
%patch51
# modify the version.c
%patch52
fi

%build
(cd gcc; autoconf)
#(cd libiberty; autoconf)
rm -rf obj-%{TARGET}
mkdir obj-%{TARGET}
cd obj-%{TARGET}
# I want to pass CFLAGS, but the stupid makefile uses it for both
# compilation and cross-compilation, I only want it for compilation.
# Hence I define CC instead, to use the CFLAGS I desire.
CC="cc $RPM_OPT_FLAGS"							\
	../configure							\
		--with-headers=%{prefix}/%{TARGET}/include		\
		--enable-languages="c,c++"				\
		--prefix=%{prefix}					\
		--host=%{HOST}						\
		--target=%{TARGET}					\
		--enable-threads=posix					\
		--enable-shared
PATH=$PATH:%{prefix}/bin make cross

%install
rm -rf $RPM_BUILD_ROOT
cd obj-%{TARGET}
PATH=$PATH:%{prefix}/bin make install prefix=$RPM_BUILD_ROOT%{prefix}
#mv $RPM_BUILD_ROOT%{prefix}/bin/gcjh $RPM_BUILD_ROOT%{prefix}/bin/%{TARGET}-gcjh 
#mv $RPM_BUILD_ROOT%{prefix}/bin/jv-scan $RPM_BUILD_ROOT%{prefix}/bin/%{TARGET}-jv-scan
#mv $RPM_BUILD_ROOT%{prefix}/bin/jcf-dump $RPM_BUILD_ROOT%{prefix}/bin/%{TARGET}-jcf-dump
mv $RPM_BUILD_ROOT%{prefix}/bin/gcov $RPM_BUILD_ROOT%{prefix}/bin/%{TARGET}-gcov
rm -rf $RPM_BUILD_ROOT%{prefix}/info
rm -rf $RPM_BUILD_ROOT%{prefix}/man
rm $RPM_BUILD_ROOT%{prefix}/lib/libiberty.a
rm -rf $RPM_BUILD_ROOT%{prefix}/doc

%files
#
# For user bins:
#
%{prefix}/bin/%{TARGET}-*
#
# For lib/gcc-lib/...
#
%{prefix}/lib
#
# For libg++ and libstc++ libs:
#
%{prefix}/%{TARGET}/lib/*
#
# For include/g++:
#
%{prefix}/include

%changelog -n cross-arm-gcc-core
* Mon Jul 09 2001 - uli@suse.de
- fixed version number (D'oh!)
- fixed to build
* Mon Jul 09 2001 - uli@suse.de
- synced with main gcc package (update -> 2.95.3)
* Wed Mar 14 2001 - bk@suse.de
- removed /usr/src/linux, there is no lx_suse there or needed.
* Fri Jan 05 2001 - uli@suse.de
- initial package
%changelog -n cross-arm-gcc
* Mon Jul 09 2001 - uli@suse.de
- synced with main gcc package (update -> 2.95.3)
* Tue Mar 27 2001 - ro@suse.de
- autoconf in libiberty
* Tue Mar 13 2001 - bk@suse.de
- don't mv g++ include dir, fixes g++ not finding these files
- fix filelist
* Mon Mar 12 2001 - bk@suse.de
- add --enable-languages="c,c++" to configure and reformat call
* Fri Jan 05 2001 - uli@suse.de
- initial package
%changelog -n cross-ppc-gcc-core
* Mon Jul 09 2001 - uli@suse.de
- fixed version number (D'oh!)
- fixed to build
* Mon Jul 09 2001 - uli@suse.de
- synced with main gcc package (update -> 2.95.3)
* Sat Dec 30 2000 - peterb@suse.de
- Fixed error in spec file, where requirements are listed
* Sat Dec 16 2000 - peterb@suse.de
- Added patch to allow configure to understand ia64 hosts
* Sat Dec 09 2000 - peterb@suse.de
- Fixed out of date dependency upon libc to on on glibc
* Mon Nov 27 2000 - aj@suse.de
- Add reload.diff to fix problem on x86 reported on linux-kernel.
* Sat Nov 25 2000 - peterb@suse.de
- Initial creation.
%changelog -n cross-ppc-gcc
* Mon Jul 09 2001 - uli@suse.de
- fixed to build
* Mon Jul 09 2001 - uli@suse.de
- synced with main gcc package (update -> 2.95.3)
* Tue Mar 27 2001 - ro@suse.de
- autoconf in libiberty
* Wed Mar 14 2001 - bk@suse.de
- don't mv g++ include dir, fixes g++ not finding these files
- fix filelist
* Mon Mar 12 2001 - bk@suse.de
- add --enable-languages="c,c++" to configure and reformat call
* Sat Dec 16 2000 - peterb@suse.de
- Added patch to allow configure to understand ia64 hosts
* Sat Dec 09 2000 - peterb@suse.de
- Fixed out of date dependency upon libc to on on glibc
* Mon Nov 27 2000 - aj@suse.de
- Add reload.diff to fix problem on x86 reported on linux-kernel.
* Sat Nov 25 2000 - peterb@suse.de
- Initial creation.
%changelog -n cross-x86-gcc-core
* Mon Jul 09 2001 - uli@suse.de
- fixed version number (D'oh!)
- fixed to build
* Mon Jul 09 2001 - uli@suse.de
- synced with main gcc package (update -> 2.95.3)
* Sat Dec 30 2000 - peterb@suse.de
- Fixed error in spec file, where requirements are listed
* Sat Dec 16 2000 - peterb@suse.de
- Added patch to allow configure to understand ia64 hosts
* Sat Dec 09 2000 - peterb@suse.de
- Fixed out of date dependency upon libc to on on glibc
* Mon Nov 27 2000 - aj@suse.de
- Add reload.diff to fix problem on x86 reported on linux-kernel.
* Sat Nov 25 2000 - peterb@suse.de
- Initial creation.
%changelog -n cross-x86-gcc
* Mon Jul 09 2001 - uli@suse.de
- fixed to build
* Mon Jul 09 2001 - uli@suse.de
- synced with main gcc package (update -> 2.95.3)
* Wed Mar 14 2001 - bk@suse.de
- don't mv g++ include dir, fixes g++ not finding these files
- fix filelist
* Mon Mar 12 2001 - bk@suse.de
- add --enable-languages="c,c++" to configure and reformat call
* Sat Dec 16 2000 - peterb@suse.de
- Added patch to allow configure to understand ia64 hosts
* Sat Dec 09 2000 - peterb@suse.de
- Fixed out of date dependency upon libc to on on glibc
* Mon Nov 27 2000 - aj@suse.de
- Add reload.diff to fix problem on x86 reported on linux-kernel.
* Sat Nov 25 2000 - peterb@suse.de
- Initial creation.
